# $Revision: 1.44 $, $Date: 2002/07/29 11:59:18 $

#
# _with_altconfig <name>  - alternative busybox config file (replaces default one)
#                           you should define cfgfile macro, i.e.
#
#       rpm --rebuild busybox.*.src.rpm --with altconfig --define "cfgfile bb-emb-config.h"
#
#
# _with_linkfl            - creates links to busybox binary and puts them into file list;
#
# Options below are useful, when you want fileutils and grep providing.
# For example, ash package requires fileutils and grep.
#
# _with_fileutl_prov      - adds fileutils providing
# _with_grep_prov         - adds grep providing
#
#
# Option below is useful, when busybox is built with shell support.
#
# _with_sh_prov           - adds /bin/sh providing
#
#
# WARNING! Shell, filetuils and grep providing may depend on config file!
# Fileutils, grep and shell provided with busybox have not such
# functionality as their GNU countenders.
#
#
# _without_static         - don't build static version
#

Summary:	Set of common unix utils for embeded systems
Summary(pl):	Zestaw narzdzi uniksowych dla systemw wbudowanych
Summary(pt_BR):	BusyBox  um conjunto de utilitrios UNIX em um nico binrio
Name:		busybox
Version:	0.60.2
Release:	8
License:	GPL
Group:		Applications
Source0:	ftp://ftp.lineo.com/pub/busybox/%{name}-%{version}.tar.gz
%{!?_with_altconfig:Source1:	%{name}-config.h}
%{?_with_altconfig:Source1:	%{cfgfile}}
Patch0:		%{name}-logconsole.patch
Patch1:		%{name}-tee.patch
Patch3:		%{name}-printf-gettext.patch
Patch4:		%{name}-loadfont.patch
Patch5:		%{name}-cread.patch
Patch6:		%{name}-malloc.patch
Patch7:		%{name}-pivot_root.patch
Patch8:		%{name}-child.patch
URL:		http://busybox.lineo.com/
%{?_with_fileutl_prov:Provides:	fileutils}
%{?_with_grep_prov:Provides:	grep}
%{?_with_sh_prov:Provides:	/bin/sh}
%{!?_without_static:BuildRequires:	glibc-static}
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
BusyBox combines tiny versions of many common UNIX utilities into a
single small executable. It provides minimalist replacements for most
of the utilities you usually find in fileutils, shellutils, findutils,
textutils, grep, gzip, tar, etc. BusyBox provides a fairly complete
POSIX environment for any small or embedded system. The utilities in
BusyBox generally have fewer options than their full-featured GNU
cousins; however, the options that are included provide the expected
functionality and behave very much like their GNU counterparts.

BusyBox has been written with size-optimization and limited resources
in mind. It is also extremely modular so you can easily include or
exclude commands (or features) at compile time. This makes it easy to
customize your embedded systems. To create a working system, just add
a kernel, a shell (such as ash), and an editor (such as elvis-tiny or
ae).

%description -l pl
BusyBox skada mae wersje wielu narzdzi uniksowych w jeden may plik
wykonywalny. Zapewnia minimalne zastpniki wikszoci narzdzi
zawartych w pakietach fileutils, shellutils, findutils, grep, gzip,
tar itp. BusyBox daje w miar kompletne rodowisko POSIX dla maych
lub wbudowanych systemw. Narzdzia maj mniej opcji ni ich pene
odpowiedniki GNU, ale maj podstawow funkcjonalno. Do dziaajcego
systemu potrzeba jeszcze tylko kernela, shella (np. ash) oraz edytora
(np. elvis-tiny albo ae).

%description -l pt_BR
BusyBox combina verses reduzidas de muitos utilitrios UNIX num nico
executvel, fornecendo substitutos minimalistas para muitos dos
executveis encontrados em pacotes como fileutils, shellutils,
findutils, textutils, grep, gzip, tar, etc. Os utilitrios do BusyBox
em geral tm menos opes que os utilitrios GNU, mas as opes
implementadas comportam-se de maneira similar aos equivalentes GNU.

%package static
Summary:	Static busybox
Summary(pl):	Statycznie linkowany busybox
Group:		Applications

%description static
Static busybox.

%description static -l pl
Statycznie linkowany busybox.

%prep
%setup -q
%patch0 -p1
%patch1 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1

%build
cp -f %{SOURCE1} Config.h

%if %{?_without_static:0}%{!?_without_static:1}
%{__make} \
	CFLAGS_EXTRA="%{rpmcflags}" \
	LDFLAGS="%{rpmldflags} -static"
mv -f busybox busybox.static
%{__make} clean
%endif

%{__make} \
	CFLAGS_EXTRA="%{rpmcflags}" \
	LDFLAGS="%{rpmldflags}" \
	CC="%{__cc}"

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_bindir},%{_mandir}/man1,%{_libdir}/busybox}

%{!?_without_static:install busybox.static $RPM_BUILD_ROOT%{_bindir}}

%{?!_with_linkfl:install busybox $RPM_BUILD_ROOT%{_bindir}}
install busybox.links $RPM_BUILD_ROOT%{_libdir}/busybox
install docs/BusyBox.1 $RPM_BUILD_ROOT%{_mandir}/man1
echo ".so BusyBox.1" > $RPM_BUILD_ROOT%{_mandir}/man1/busybox.1

# install links to busybox binary, when linkfl is defined
%{?_with_linkfl:make install PREFIX=$RPM_BUILD_ROOT}

gzip -9nf AUTHORS TODO Changelog README

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc *.gz Config.h

%{?!_with_linkfl: %attr(755,root,root) %{_bindir}/busybox}

%if %{?_with_linkfl:1}%{?!_with_linkfl:0}
%attr(755,root,root) /bin/*
%attr(755,root,root) /sbin/*
%attr(755,root,root) %{_bindir}/*
%attr(755,root,root) %{_sbindir}/*
%endif

%{_libdir}/busybox
%{_mandir}/man1/*

%if %{?_without_static:0}%{!?_without_static:1}
%files static
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/busybox.static
%endif

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld.org.pl>
All persons listed below can be reached at <cvs_login>@pld.org.pl

$Log: busybox.spec,v $
Revision 1.44  2002/07/29 11:59:18  malekith
- added child.patch so busybox init will take over orphaned processes
  thus preventing zilions of Z processes on bootdisk
- release 8

Revision 1.43  2002/05/16 20:02:40  qboosh
- added Config.h to doc (may be useful - to know what capabilities are set)

Revision 1.42  2002/05/10 12:57:09  wrobell
- do not install busybox binary twice when using linkfl option
- rel. 7

Revision 1.41  2002/05/10 12:17:10  wrobell
- added new options:
  - altconfig     - build busybox with alternative busybox config file
  - linkfl        - creates links to busybox binary and includes them into filelist
  - fileutil_prov - adds fileutils providing
  - grep_prov     - adds grep providing
  - sh_prov       - adds /bin/sh providing
- rel. 6

Revision 1.40  2002/04/25 15:56:05  arturs
fixed a small typo

Revision 1.39  2002/04/25 09:06:54  kloczek
- updated to 0.60.2 (release 5).

Revision 1.38  2002/04/25 08:39:04  kloczek
- merge translations from Conectiva.

Revision 1.37  2002/03/08 14:35:09  malekith
- pass CC to make

Revision 1.36  2002/03/05 18:09:01  marcus
- remove uclibc stuff
- rel.17.

Revision 1.35  2002/02/23 01:33:37  kloczek
- adapterized.

Revision 1.34  2002/02/22 23:28:44  kloczek
- removed all Group fields translations (our rpm now can handle translating
  Group field using gettext).

Revision 1.33  2002/01/21 18:15:46  malekith
- BOOT -> embed
- rel 16

Revision 1.32  2002/01/18 02:12:32  kloczek
perl -pi -e "s/pld-list\@pld.org.pl/feedback\@pld.org.pl/"

Revision 1.31  2002/01/17 13:28:59  qboosh
- removed obsolete TODO comment

Revision 1.30  2002/01/17 13:26:51  qboosh
- release 15: added -static subpackage

Revision 1.29  2001/10/29 19:14:40  malekith
- rel 14
- new version of malloc patch and new pivot_root patch

Revision 1.28  2001/09/07 23:33:00  klakier
- removed sh_name.patch

Revision 1.27  2001/09/07 23:19:12  klakier
- config changed: disables ash, vi, enables lash
  Reasons:
  1) busybox ash makes trouble (crashes on some scripts) and is
     horribly slow
  2) _extremely_ small vi applet is provided by e3 package
  3) lash is poor bu it has some nice interactive features (completion, history)

  Please do not introduce substantial changes to this package without
  testing the results before! If you really need changes please consult them
  on one of pld mailing lists!!!

Revision 1.26  2001/08/30 22:42:48  filon
- updated to 0.60.1 (modified patches)
- there are much more applets (ash, vi, ..)
- it's smaller than ever before
- added ash to config, it's much smaller than ash-BOOT

Revision 1.25  2001/08/28 12:13:24  wiget
fix BOOT subpackage
release 12

Revision 1.24  2001/08/19 15:47:05  kloczek
- remove -s from LDFLAGS.

Revision 1.23  2001/08/18 11:03:00  malekith
- fixed, now builds correctly

Revision 1.22  2001/08/18 09:41:38  malekith
- fixes insmod problems with 3c boomerang
- rel 11

Revision 1.21  2001/08/09 16:37:24  qboosh
- base package is dynamically linked and has pl summary/description
- fixed BOOT bcond

Revision 1.20  2001/08/01 12:36:44  malekith
- enabled nc (netcat)

Revision 1.19  2001/07/30 15:51:56  klakier
- rel 9
- syslogd and klogd added to Config.h

Revision 1.18  2001/07/05 10:35:41  kloczek
- BuildRequires for uClibc-devel-BOOT only when %%{BOOT is defined.

Revision 1.17  2001/07/05 08:49:06  wiget
added pivot_root and freeramdisk; release 8

Revision 1.16  2001/06/13 09:23:30  malekith
- rel 7
- added cread patch (can anybody check if it works?)

Revision 1.15  2001/06/12 13:25:51  klakier
- rel 6
- loadfont added to config
- added loadfont.patch to be able to load lat2-16 font
  (THIS PATCH IS VERY NASTY HACK, but works)

Revision 1.14  2001/05/31 15:14:26  malekith
- added printf-gettext batch by /me
- rel 5

Revision 1.13  2001/05/22 22:51:05  klakier
- added -m386 for BOOT

Revision 1.12  2001/05/21 19:02:36  klakier
- rel 4
- compiled against uClibc 20010521

Revision 1.11  2001/05/21 11:41:41  klakier
- fixed broken 'cosmetics' from rev 1.9. Please DO NOT make
  substantial changes in %build or %install without testing it

Revision 1.10  2001/05/20 10:53:48  klakier
- rel 3 (fixed sh_name.patch)

Revision 1.9  2001/05/20 10:16:18  kloczek
- cosmetics.

Revision 1.8  2001/05/19 11:20:40  klakier
- added sh_name patch and change /bin/sh to /bin/lash (sh is in ash-BOOT)

Revision 1.7  2001/05/16 15:14:05  klakier
- changes

Revision 1.6  2001/04/24 04:42:17  kloczek
- release 2.

Revision 1.5  2001/04/13 13:56:14  klakier
- added BOOT package
- linked statically against uClibc

Revision 1.4  2001/04/11 22:26:33  kloczek
- removed outdated 0.50 patch.

Revision 1.3  2001/04/11 20:37:46  areq
- 0.51
- comment busybox-0.50.patch

Revision 1.2  2001/04/04 18:09:00  kloczek
- added more %description,
- added full Source url,
- move busybox executable to %%{_bindir},
- added man page for busybox,
- some style fixes in %install.

Revision 1.1  2001/04/03 17:06:40  malekith
from scratch.
